-------------------------------------------------------------------------
ls -al
total 313
drwx------  2 fischman      512 Apr  1 08:08 .
drwx------  4 fischman      512 Apr  1 08:01 ..
-rw-------  1 fischman      232 Apr  1 08:02 Makefile
-rwx------  1 fischman   303104 Apr  1 08:03 cpi
-rw-------  1 fischman     1617 Apr  1 08:01 cpi.c
-rw-------  1 fischman     1893 Apr  1 08:03 cpi.o
-rw-------  1 fischman       16 Apr  1 08:03 machines
-------------------------------------------------------------------------
08:08:23{ttyp3@oak}~/t/t2//> cat Makefile 
CC = gcc
LDFLAGS = -L/c1/jacobi/guest/eijkhout/mpich/lib/sun4/ch_p4
CFLAGS = -I/c1/jacobi/guest/eijkhout/mpich/include
LIBS = -lmpi

all: cpi

cpi: cpi.o
	gcc $(LDFLAGS) -o cpi cpi.o $(LIBS)

cpi.o: cpi.c
	$(CC) $(CFLAGS) -c cpi.c
-------------------------------------------------------------------------
08:08:26{ttyp3@oak}~/t/t2//> cat cpi.c
#include "mpi.h"
#include <stdio.h>
#include <math.h>

double f(a)
double a;
{
    return (4.0 / (1.0 + a*a));
}

int main(argc,argv)
int argc;
char *argv[];
{
    int done = 0, n, myid, numprocs, i, rc;
    double PI25DT = 3.141592653589793238462643;
    double mypi, pi, h, sum, x, a;
    double startwtime, endwtime;
    int  namelen;
    char processor_name[MPI_MAX_PROCESSOR_NAME];

    MPI_Init(&argc,&argv);
    MPI_Comm_size(MPI_COMM_WORLD,&numprocs);
    MPI_Comm_rank(MPI_COMM_WORLD,&myid);
    MPI_Get_processor_name(processor_name,&namelen);

    fprintf(stderr,"Process %d on %s\n",
	    myid, processor_name);

    n = 0;
    while (!done)
    {
        if (myid == 0)
        {
	    if (n==0) n=100; else n=0;

	    startwtime = MPI_Wtime();
        }
        MPI_Bcast(&n, 1, MPI_INT, 0, MPI_COMM_WORLD);
        if (n == 0)
            done = 1;
        else
        {
            h   = 1.0 / (double) n;
            sum = 0.0;
            for (i = myid + 1; i <= n; i += numprocs)
            {
                x = h * ((double)i - 0.5);
                sum += f(x);
            }
            mypi = h * sum;

            MPI_Reduce(&mypi, &pi, 1, MPI_DOUBLE, MPI_SUM, 0, MPI_COMM_WORLD);

            if (myid == 0)
	    {
                printf("pi is approximately %.16f, Error is %.16f\n",
                       pi, fabs(pi - PI25DT));
		endwtime = MPI_Wtime();
		printf("wall clock time = %f\n",
		       endwtime-startwtime);	       
	    }
        }
    }
    MPI_Finalize();
}
-------------------------------------------------------------------------
08:08:31{ttyp3@oak}~/t/t2//> cat machines 
oak
oak
oak
oak
-------------------------------------------------------------------------
08:08:34{ttyp3@oak}~/t/t2//> mpirun -machinefile machines -np 1 cpi
Process 0 on oak.mathnet
pi is approximately 3.1416009869231254, Error is 0.0000083333333323
wall clock time = 0.013839 
